# -----------------------------------------------------------------------------
sub sqlAlerts
# -----------------------------------------------------------------------------
{
  ($thishost) = @_;

  ##print "up=$up[$thishost] title=$title[$thishost]\n";
  if ($up[$thishost] ne "Y")
  {
    logit("(Down/Inhibited)",$thishost);
    return 1;
  }

  #if (&check_inhib($thishost) eq "Y")
  #{
  #  $up[$thishost] = "I";
  #  return;
  #}
  #if ($up[$thishost] eq "D")
  #{
  #  logit("(No software download)",$thishost);
  #  #
  #  # 3.19I Fix for BBN - A condition can occur where the "up" flag is set to
  #  #  D from a failed download, but the download_flag is set to 1. This is a
  #  #  place where the code is always executed for every instance, so I am
  #  #  adding a line to turn off the download_flag which will cause the
  #  #  download subroutine to retry the download next time. If that succeeds,
  #  #  the download subroutine will turn off the D value of "up".
  #  #
  #  return;
  #}

  &remsh("$perlpath[$thishost] $probe[$thishost] checklog",$tmpfl3,$thishost);
  system("cp $tmpfl3 /tmp/zdbamondiag.txt");
  open(TMPFL3, "$tmpfl3"  ) || &error_msg("Can't open input $tmpfl3 - $!");
  
  my $sqlevent_flag = 0;
  my $sqlevent_text = "";
  my $sqlcurrentlog_data = ""; 
  my $sqlcurrentlogagent_data = ""; 
  my $sql_db_log_event_cnt = 0;
  my $sql_db_log_event_data = "";
  my $sql_ag_log_event_cnt = 0;
  my $sql_ag_log_event_data = "";

  while(<TMPFL3>)
  {
    &parse;

    if ($F1 eq "Event:")  
    {
      $sqlevent_flag = 1;
      $sql_db_log_event_cnt++;
      $sql_db_log_event_data .= "$sql_db_log_event_cnt. $F0"; 
    }

    if ($F1 eq "EventAgent:")  
    {
      $sqleventagent_flag = 1;
      $sql_ag_log_event_cnt++;
      $sql_ag_log_event_data .= "$sql_ag_log_event_cnt. $F0"; 
    }

    if ($F1 eq "dbamon_mssql.pl" && $F2 eq "CurrentLog:") 
    { 
      if    ($F0 =~ /backup/i) { $acolor = "lightgreen"; }
      elsif ($F0 =~ /error/i)  { $acolor = "pink"; } 
      else                     { $acolor = "lightgrey"; } 
  
      $sqlcurrentlog_data .= "<tr bgcolor=$acolor>" . substr($F0,28) . "\n" ; 
    }

    if ($F1 eq "dbamon_mssql.pl" && $F2 eq "CurrentLogAgent:") 
    { 
      if   ($F0 =~ /error/i)  { $acolor = "pink"; } 
      else                    { $acolor = "lightgrey"; } 
  
      $sqlcurrentlogagent_data .= "<tr bgcolor=$acolor>" . substr($F0,33) . "\n" ; 
    }
  }
  close(TMPFL3);

  my $zevent_flag = 0; 
  
  if ($sqlevent_flag == 1)
  {
    open(TMPFL2, ">$tmpfl2") || &error_msg("Can't open output $tmpfl2 - $!");
    print TMPFL2 "-- Report of SQL DB Log Error(s) Found ($sql_db_log_event_cnt):\n";
    print TMPFL2 "$sql_db_log_event_data";
    close(TMPFL2); 
    &event("C",$thishost,"Found $sql_db_log_event_cnt SQL DB Log Alert(s)","MSSQL_SQL_Log","DBA651C",$tmpfl2);
    $zevent_flag = 1; 
  }

  if ($sqleventagent_flag == 1)
  {
    open(TMPFL2, ">$tmpfl2") || &error_msg("Can't open output $tmpfl2 - $!");
    print TMPFL2 "-- Report of SQL Agent Log Error(s) Found ($sql_db_log_event_cnt):\n";
    print TMPFL2 "$sql_ag_log_event_data";
    close(TMPFL2); 
    &event("C",$thishost,"Found $sql_db_log_event_cnt SQL Agent Log Alert(s)","MSSQL_SQL_Log","DBA651C",$tmpfl2);
    $zevent_flag = 1; 
  }

  if ($zevent_flag == 0)
  {
    &logit("OK",$thishost); 
  }

  #---- Write last N lines of the CURRENT LOG

  &logDetails($thishost,"<br><a name='sqlAlerts'> <h3>MSSQL Current SQL Log - The Most Recent 50 Lines (Descending Timestamp)</h3>");
  &logDetails($thishost,"<table border=1 bgcolor=$table_bgcolor style='font-family:$www_font;font-size:10pt;'>");
  &logDetails($thishost,"<tr bgcolor=$table_headbgcolor>
    <th>$f_s Timestamp
    <th>$f_s Source
    <th>$f_s Text
  ");
  &logDetails($thishost,$sqlcurrentlog_data) ; 
  &logDetails($thishost,"</table>") ; 

  &logDetails($thishost,"<br><h3>MSSQL Current AGENT Log - The Most Recent 50 Lines (Descending Timestamp)</h3>");
  &logDetails($thishost,"<table border=1 bgcolor=$table_bgcolor style='font-family:$www_font;font-size:10pt;'>");
  &logDetails($thishost,"<tr bgcolor=$table_headbgcolor>
    <th>$f_s Timestamp
    <th>$f_s ErrorLevel
    <th>$f_s Text
  ");
  &logDetails($thishost,$sqlcurrentlogagent_data) ; 
  &logDetails($thishost,"</table><hr>") ; 

}
# -----------------------------------------------------------------------------
1;
