# -----------------------------------------------------------------------------
sub sqlBkup
# -----------------------------------------------------------------------------
{
  ($thishost) = @_;

  ##print "up=$up[$thishost] title=$title[$thishost]\n"; 
  if ($up[$thishost] ne "Y")
  {
    logit("(Down/Inhibited)",$thishost);
    return 1;
  }

  if (&check_inhib($thishost) eq "Y")
  {
    $up[$thishost] = "I";
    return;
  }

  if ($backup_age[$thishost] eq "" || $backup_age[$thishost] eq "N")
  {
    logit("Backup Aging not requested for this instance",$thishost);
    return 0;
  }

  #---- Backup_Age "BIAS" logic - START
  $ba_bias_file = "/opt/dbamon/adm/ba_bias_MSSQL.txt";
  if (-e "$ba_bias_file")
  {
    &logit("sqlBkup.pl | Found ba_bias_file=$ba_bias_file",$thishost);
    chop($ba_bias = `cat $ba_bias_file | grep -v '^#' | head -1`);
    if ($ba_bias > 0)
    {
      $backup_age[$thishost] = $backup_age[$thishost] * $ba_bias;
      &logit("sqlBkup.pl | Backup bias value ba_bias=$ba_bias is valid - Updated backup_age[$thishost]=$backup_age[$thishost]",$thishost);
    }
  }
  #---- Backup_Age "BIAS" logic - END

  if ($up[$thishost] eq "D")
  {
    logit("(No software download)",$thishost);
    #
    # 3.19I Fix for BBN - A condition can occur where the "up" flag is set to
    #  D from a failed download, but the download_flag is set to 1. This is a
    #  place where the code is always executed for every instance, so I am
    #  adding a line to turn off the download_flag which will cause the
    #  download subroutine to retry the download next time. If that succeeds,
    #  the download subroutine will turn off the D value of "up".
    #
    return;
  }

  if ($use_repository eq "Y")
  {
    $rc = &baICheck($thishost);
    if ($rc > 0)
    {
      $bainhibit[$thishost] = 1;
      $bckhours_c[$thishost] = "black";
      $bckhours[$thishost]   = "(I)";
      $msg = sprintf("Backup Age Checking Inhibited - Start: %s End: %s Created: %s User: %s Reason: %s",$bai_sts,$bai_ets,$bai_ts,$bai_user,$bai_reason);
      &logit($msg,$thishost);
      return 0 ;
    }
  }
  else
  {
    $msg = sprintf("Backup Aging Inhibit not possible because dbamonrc Use_Oracle: ne Y");
    &logit($msg,$thishost);
  }

  remsh("$perlpath[$thishost] $probe[$thishost] bkup $run_surgery[$thishost]",$tmpfl3,$thishost);
  ##system("cat $tmpfl3");

  $maxts = "";

  $bckhours_c[$thishost] = "lime";
  my $finalage = -999;

  &logDetails($thishost,"<br><a name='#sqlBkup'> <h3>MSSQL Database Backups</h3>");
  &logDetails($thishost,"<h5>DB's: msdb, master and ($backup_dbs[$thishost]) from DBC Backup_Check_DBs: Are Being Tracked For Backup_Age: </h5>");
  &logDetails($thishost,"<table border=1 bgcolor=$table_bgcolor>");
  &logDetails($thishost,"<tr bgcolor=$table_headbgcolor>$f_s
    <th>$f_s Database<br>Name
    <th>$f_s Monitoring Threshold<br>(Hours)
    <th>$f_s Age Of<br>Most Recent<br>Full/Incr.<br>Backup (Hours)
    <th>$f_s Most Recent<br>Full/Incr.<br>Backup Date
    <th>$f_s Most Recent<br>Full/Incr.<br>Backup Time
    <th>$f_s Message
  ");

  $delflag = 0;
  #---- 2011/08/30 BB: Changed from an array to local var
  ## $backup_details[$thishost] = ""; 
  my $backup_details = ""; 
  $sqlBkupTLogStack[$thishost] = ""; 

  $lstmeth = "";

  $max_age = 0; 

  undef %events_811;
  undef $alltext_811;

  open(TMPFL3, "$tmpfl3"  ) || &error_msg("Can't open input $tmpfl3 - $!");
  while(<TMPFL3>)
  {
    &parse;

    ##print "F1=$F1 F2=$F2 F3=$F3\n";

    $mssql_backup_job_logic = 0;
    if ($F2 eq "BACKUPJOB:" && $mssql_backup_job_logic)
    {
      chop($evalstmt = substr($F0,27)); 
      $evalstmt =~ s/\\\\\$/\\\$/g;
      ##$evalstmt =~ s/'/\\'/g;
      eval $evalstmt;

      if ($@)
      {
	##print "evalstmt=$evalstmt";
	##print "evalout=$@\n"; 
        next;
      }

      ##print "jobname=$jobname jobcmd=$jobcmd\n";

      $statement  = "
	insert into dbamon.mssql_backup_jobs
	  (server,jobname,jobcmd,jobtype)
	values
	  (\'$fqhostname[$h]\', \'$jobname\', \'$jobcmd\', \'$jobtype\')
      ";

      runSQL($statement,1);
      ##print "statement=$statement sqlerror=$sqlerror sqlcode=$sqlcode\n" if $sqlerror && $sqlerror !~ /unique constraint/;
    }

    #---- Backup detail report data
    #---- BckDet: <xx> WSS_Content_Frontier I 2007/11/14-21:18:41 15
    if ($F1 eq "BckDet:")
    {
      ##$backup_details[$thishost] .= substr($F0,8); 
      $backup_details .= substr($F0,8); 
    }

    #---- Backup age (TLOG) data
    if ($F1 eq "BckAgeTLOG:")
    {
      $sqlBkupTLogStack[$thishost] .= $F0; 
    }

    #---- Backup age data
    if ($F1 eq "BckAge:")
    {
      $db      = $F2;
      $age     = $F3;
      $lstdate = $F4;
      $lsttime = $F5;
      $lstmeth = $F6 if $F6;

      ($lstts = $lstdate) =~ s/\-/\//g;
      $lstts .= '-' . substr($lsttime,0,8);
      $maxts = $lstts if $lstts > $maxts;


      if (
          lc $db eq "tempdb" || 
          lc $db eq "model" || 
          lc $db eq "northwind" || 
          lc $db eq "pubs" 
         )
      {
        &logit("Backup Not Applicable - Special DB=$db",$thishost);
        next;
      }

      $db_lc = lc $db; 
      ##print "db=$db db_lc=$db_lc lm=$lstmeth lstts=$lstts maxts=$maxts db_attrs=$db_attrs[$thishost]{$db_lc}\n";
      if ($db_attrs[$thishost]{$db_lc} =~ /Snapshot/)
      {
        &logit("Backup Not Applicable - Snapshot DB=$db",$thishost);
        next;
      }

      $zd = $lstdate;
      $zd =~ s/-/\//g;
      $zt = substr($lsttime,0,8);
      $zts = "$zd-$zt";
      $zts = "(Never)" if $zts eq "-";

      if ($delflag == 0) 
      {
	# Delete old data for this server
	$sqlstmt = "delete from dbamon.mssql_backup where server = '$titleraw[$thishost]'";
	&runSQL($sqlstmt);
        $delflag = 1;
      }

      # insert a new row for this db;
      $sqltext  = "insert into dbamon.mssql_backup (dbamonmode,server,db,bkage,bkts,dbcfile) \n";

      $age = -1 if $age eq "";

      $sqltext .= "values ('$modeout', 
			     '$titleraw[$thishost]',
			     '$db',
			     '$age', 
			     '$zts',
			     '$dbcfile[$thishost]'
			     )";
      &runSQL($sqltext);
      ##print "inserted $sqltext\n";

      next if $backup_age[$thishost] eq "";

      # Just in case we exceed, set these vars and make report
      $rounded1 = int($age / 10);
      $rounded1 = $rounded1 * 10;
      $rounded2 = $rounded1 + 9;

      #---- Save this for later  
      if ($age > $max_age)
      {
        $max_age = $age; 
        $max_range = "${rounded1}-${rounded2}";
      }

      $dbchk = ",$db,";
      print "-- found db=$db age=$age bat=$backup_age[$thishost] bcd=$backup_dbs[$thishost] dbchk=$dbchk\n" if $debug_22;

      $bck_msg = "";

      $rerun = 0;
      $bcksev = "C";
      $bckcolor = "lime";
      $bckrerun_msg = "";

      open(TMPFL6, ">$tmpfl6") || &error_msg("Can't open output $tmpfl6 - $!");
      print TMPFL6 "---------------------------------------------------\n";
      print TMPFL6 "Most recent successful D/I backup of database: $db\n";
      print TMPFL6 "Date: $lstdate \n";
      print TMPFL6 "Time: $lsttime \n";
      print TMPFL6 "---------------------------------------------------\n";
      print TMPFL6 "\nAll Registered Backups For Database: $db \n"; 
      print TMPFL6 "<table border=1> \n ";
      print TMPFL6 "<tr bgcolor=$table_headbgcolor><th>$f_s Database Name<th>$f_s Backup Timestamp<th>$f_s Backup Type<th>$f_s Age (Hours)</tr>\n";
      ##print "cat $tmpfl3 | grep '<tr' | grep '$db' \n";
      ##system("cat $tmpfl3 | grep '<tr' | grep '$db' ");
      print TMPFL6 `cat $tmpfl3 | grep '<td>$db '`;
      print TMPFL6 "</table> \n";
      close(TMPFL6);

      if (index($backup_dbs[$thishost],lc $dbchk) > -1 || $db eq "master" || $db eq "msdb" || $backup_dbs[$thishost] eq ",all,")
      {
        if ($age > $finalage) { $finalage = $age; }

        # Determine whether to try a rerun 

	print "  DB HIT #1 db=$db dbchk=$cbchk iter_count=$iter_count backup_rerun_iter[$thishost]=$backup_rerun_iter[$thishost]\n" if $debug_22;
	print "  DB HIT #2 age=$age backup_age[$thishost]=$backup_age[$thishost]\n" if $debug_22;

	if (
             ($age == -1 || $age > $backup_age[$thishost]) && 
              $backup_command[$thishost] ne "" && 
              $backup_rerun_iter[$thishost] != ($iter_count - 1))
	{
	  # Issue rerun
	  # Async or foreground
	  ##print "su=$system_used[$thishost] ss=$system_size[$thishost] \n";

	  if ($system_used[$thishost] > 0.1) { $amethod = "B"; }
	  else                               { $amethod = "F"; }
	  
	  $cmd = "$perlpath[$thishost] $probe[$thishost] bkrun $db $amethod \"$backup_command[$thishost]\"";
	  print "  MSSQL backup rerun $title[$thishost] cmd=$cmd \n" if $debug_22;
	  remsh($cmd,$tmpfl4,$thishost);

          if ($debug_22)
          {
	    print "DEBUG: tmpf4: \n";
            system("cat $tmpfl4 | dbamon_mailer -s 'DBAmon sqlBkup() $titleraw[$thishost] Backup Rerun $db' $debug_email");

	    print "DEBUG: End\n";
          }

	  $backup_rerun_iter[$thishost] = $iter_count;

          # Log the restart
          $zdate = &getdate;
          system("echo '$zdate $dbms[$thishost] $titleraw[$thishost] $db cmd=$cmd' >> /opt/dbamon/dat/history/backup_rerun.dat");

          # See if an error occured running command
          if (system("grep 'ERROR:' $tmpfl4") == 0)
          {
            &event("C",$thishost,"MSSQL DB=$db - Invoked Backup Failed - Method=$amethod","BkpFail","DBA515",$tmpfl4);
            $bcksev = "C";
	    $bckcolor = "red";
	    $bckrerun_msg = "(Backup Rerun Failed)";
          }
          else
          {
            &event("W",$thishost,"MSSQL DB=$db - Backup Was Invoked - Method=$amethod","BkpRerun","DBA514",$tmpfl4);
            $bcksev = "W";
	    $bckcolor = "yellow";
	    $bckrerun_msg = "(Backup Rerun Was Attempted)";
            $rerun = 1;
          }
	}

        $bckhours_c[$thishost] = $bckcolor;

        &metricsCurrent("sqlBkup()",$thishost,"BACKUP_AGE_DB",$db,$age,"",$backup_age[$thishost],"Hours since last good DB Backup for this DB: $age");

        if ($age == -1)
        {
          &event($bcksev,$thishost,"MSSQL DB=$db - Backup Never Run - Threshold=$backup_age[$thishost] $bckrerun_msg","BkpNever","DBA810$bcksev",$tmpfl6);
          $bck_msg = "$f_s <font color=$bckcolor><b>Critical Event - No Backup Ever</b></font>";
	}
        elsif ($age > $backup_age[$thishost])
        {
          # Cache this 811 event
          $z = sprintf("DB: %-20s - Hours since last good backup: %4d - Rerun status: $bckrerun_msg\n",$db,$age);
          $events_811{"$bcksev-$rounded1-$rounded2"} .= $z; 
          $alltext_811                               .= $z; 
          $bckcolor = "red";
          $bckhours_c[$thishost] = $bckcolor;
          $bck_msg = "$f_s <font color=$bckcolor><b>Event - Backup Age Threshold of $backup_age[$thishost] Exceeded</b></font>"
	}
        else
        {
	  &logit("OK - DB=$db Age=$age Threshold=$thishost",$thishost);
        }
      }
      if ($age == -1) { $zage = "<b>(Never)</b>"; }
      else            { $zage = $age; }
      &logDetails($thishost,"<tr>
        <td>$f_s <b> $db </b> 
        <td align=right>$f_s $backup_age[$thishost]
        <td align=right>$f_s $zage
        <td>$f_s $lstdate
        <td>$f_s $lsttime
        <td bgcolor=black>$f_s $bck_msg");

      &histCreate("sqlBkup()",$thishost,"BCKAGE_D",$db,$age,$backup_age[$thishost]);
      &metricsInsert("sqlBkup()",$thishost,"BCKAGE_D",$db,$age);
    }
  }
  close(TMPFL3);

  &logDetails($thishost,"</table>");

  &logDetails($thishost,"<h3>MSSQL Database Backup Details</h3>");
  &logDetails($thishost,"<table border=1 bgcolor=$table_bgcolor>");
  &logDetails($thishost,"<tr bgcolor=$table_headbgcolor>
    <th>$f_s Database<br>Name
    <th>$f_s Backup Type
    <th>$f_s Most Recent<br>Backup Timestamp<br>Of This<br>Backup Type
    <th>$f_s Age of This Backup<br>(Hours)
    <th>$f_s Age of This Backup<br>(Days)
  ");
  ##&logDetails($thishost,$backup_details[$thishost]);
  &logDetails($thishost,$backup_details);
  &logDetails($thishost,"</table><hr>");

  $bckhours[$thishost] = $finalage;
  if ($bckhours[$thishost] == -1) { $bckhours[$thishost] = "(Never)" }

  print "sqlBkup - $titleraw[$thishost] lstmeth=[$lstmeth]\n" if $debug_22;

  if    ($lstmeth eq "D" ) { $backup_method_long[$thishost] = "bkDISK"; }
  elsif ($lstmeth eq "V" ) { $backup_method_long[$thishost] = "bkVERITAS"; }
  elsif ($lstmeth eq "OB") { $backup_method_long[$thishost] = "bkOMNIBACK"; }
  elsif ($lstmeth eq "UN") { $backup_method_long[$thishost] = "bkUnknown"; }
  elsif ($lstmeth eq "CV") { $backup_method_long[$thishost] = "bkCommVault"; }
  elsif ($lstmeth eq "SY") { $backup_method_long[$thishost] = "bkSymantec"; }
  else                     { $backup_method_long[$thishost] = ""; }

  $mr_backup_date[$thishost] = $maxts; 

  #---- Create events for any cached 811's

  undef %posted_811;
  
  foreach (sort keys %events_811)
  {
    $key   = $_;
    $sev   = substr($key,0,1); 
    $range = substr($key,2); 
    $text  = $events_811{"$key"};

    $range_lower    = (split(/\-/,$key)) [1];
    $range_pct_of_t = int($range_lower / $backup_age[$thishost]) * 100 if $backup_age[$thishost] > 0;
    if ($range_pct_of_t > 200)
    {
      $this_pri = "H"; 
    }
    else
    {
      $this_pri = undef;
    }

    ##print "DEBUG - Event: 811 - key=$key sev=$sev range_lower=$range_lower range_pct_of_t=$range_pct_of_t t=$backup_age[$thishost] this_pri=$this_pri\n";

    open(TMPFL2, ">$tmpfl2") || &error_msg("Can't open output $tmpfl6 - $!");
    print TMPFL2 "$dashes\n\n";
    print TMPFL2 "------- Report of Databases Which Needed To Be Backed Up -------\n\n";
    print TMPFL2 "$alltext_811\n";
    print TMPFL2 "$dashes\n\n";
    print TMPFL2 "------- Probe Raw Data -------\n\n";
    print TMPFL2 `cat $tmpfl3`;
    close(TMPFL2);

    if (! $posted_811{$sev}) 
    {
      &event($sev,$thishost,"$max_range Hours since last backup for at least 1 DB - Threshold is $backup_age[$thishost] hours","BkpAge","DBA811",$tmpfl2,undef,undef,$this_pri);
    }
    $posted_811{$sev} = 1;
  }

  ##print "lm=$lstmeth bml=$backup_method_long[$thishost]\n";
  ##print "DEBUG - sqlBkup - bckhours_c[$thishost]=$bckhours_c[$thishost]\n";

  if ($short eq "")
  {
    $msg = sprintf("OK (%s/%s) bckhours_c=$bckhourc_c[$thishost]",$finalage,$backup_age[$thishost]);
    &logit($msg,$thishost);
  }

  #---- Userexit
  if (-x "/opt/dbamon/bin/userexit/inc_sqlbkup")
  {
    if (! $inc_userexit)
    {
      #---- Moved to main
      ##push(@INC,"/opt/dbamon/bin/userexit");
      $inc_userexit = 1;
    }
    require "inc_sqlbkup";
    &inc_sqlbkup;
  }

  #---- Save these for the summarize routine
  $bckhours_color_db[$thishost] = $bckhours_c[$thishost];
  $bckhours_value_db[$thishost] = $bckhours[$thishost]; 

}
# -----------------------------------------------------------------------------
1;
